/*
 * Copyright 2014 Federal Chancellery Austria
 * MOA-ID has been developed in a cooperation between BRZ, the Federal
 * Chancellery Austria - ICT staff unit, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.1 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * http://www.osor.eu/eupl/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 */
package at.gv.egiz.eaaf.core.impl.idp.builder;

import at.gv.egiz.eaaf.core.api.idp.IAttributeGenerator;

/**
 * @author tlenz
 *
 */
public class SimpleStringAttributeGenerator implements IAttributeGenerator<String> {

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.protocols.builder.attributes.IAttributeGenerator#buildStringAttribute(java.lang.String, java.lang.String, java.lang.String)
	 */
	@Override
	public String buildStringAttribute(String friendlyName, String name, String value) {
		return value;
		
	} 

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.protocols.builder.attributes.IAttributeGenerator#buildIntegerAttribute(java.lang.String, java.lang.String, int)
	 */
	@Override
	public String buildIntegerAttribute(String friendlyName, String name, int value) {
		return String.valueOf(value);
		
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.protocols.builder.attributes.IAttributeGenerator#buildLongAttribute(java.lang.String, java.lang.String, long)
	 */
	@Override
	public String buildLongAttribute(String friendlyName, String name, long value) {
		return String.valueOf(value);
		
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.protocols.builder.attributes.IAttributeGenerator#buildEmptyAttribute(java.lang.String, java.lang.String)
	 */
	@Override
	public String buildEmptyAttribute(String friendlyName, String name) {
		return null;
	}

}
