/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
package at.gv.egiz.eaaf.core.impl.idp.process.dao;

import java.io.Serializable;
import java.util.Map;

import at.gv.egiz.eaaf.core.impl.idp.process.ProcessInstanceState;

public class ProcessInstanceStore implements Serializable{

	private static final long serialVersionUID = -6147519767313903808L;

	/**
	 * A process instance identifier qualifies as natural primary key by satisfying these requirements
	 * ("unique, constant, required"):
	 * <ul>
	 * <li>unique value</li>
	 * <li>never changes (immutable)</li>
	 * <li>never {@code null}</li>
	 * </ul>
	 */

	private String processInstanceId;

	private String processDefinitionId;

	private String nextTaskId;

	private ProcessInstanceState processState;
	
	private Map<String, Serializable> executionContextData; 
	
	public String getProcessInstanceId() {
		return processInstanceId;
	}

	public String getProcessDefinitionId() {
		return processDefinitionId;
	}

	public String getNextTaskId() {
		return nextTaskId;
	}

	public ProcessInstanceState getProcessState() {
		return processState;
	}

	@SuppressWarnings("unchecked")
	public Map<String, Serializable> getExecutionContextData() {
		return  executionContextData;
	}

	public void setProcessInstanceId(String processInstanceId) {
		this.processInstanceId = processInstanceId;
	}

	public void setProcessDefinitionId(String processDefinitionId) {
		this.processDefinitionId = processDefinitionId;
	}

	public void setNextTaskId(String nextTaskId) {
		this.nextTaskId = nextTaskId;
	}

	public void setProcessState(ProcessInstanceState processState) {
		this.processState = processState;
	}

	public void setExecutionContextData(Map<String, Serializable> executionContextData) {
		this.executionContextData = executionContextData;
	}

}
