/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
package at.gv.egiz.eaaf.core.impl.idp.process.model;

import java.io.Serializable;

import org.apache.commons.collections4.CollectionUtils;

/**
 * Represents an end event. Process execution terminates when an end event is reached.
 * 
 * @author tknall
 */
public class EndEvent extends ProcessNode implements Serializable {

	private static final long serialVersionUID = 1L;

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("EndEvent [");
		if (getId() != null) {
			builder.append("id=");
			builder.append(getId());
		}
		if (CollectionUtils.isNotEmpty(getIncomingTransitions())) {
			if (builder.length() > 0) {
				builder.append(", ");
			}
			builder.append("incomingTransitions=");
			builder.append(getIncomingTransitions());
		}
		if (CollectionUtils.isNotEmpty(getOutgoingTransitions())) {
			if (builder.length() > 0) {
				builder.append(", ");
			}
			builder.append("outgoingTransitions=");
			builder.append(getOutgoingTransitions());
		}
		builder.append("]");
		return builder.toString();
	}

}
