/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
package at.gv.egiz.eaaf.core.impl.utils;

import java.util.List;

public class ArrayUtils {

	/**
	 * Check if a String 's' is part of a List 'l' in qualsIgnoreCase mode
	 * 
	 * @param s Search String
	 * @param l List of String elements
	 * @return true if 's' is in 'l', otherwise false
	 */
	public static boolean containsCaseInsensitive(String s, List<String> l){
		if (l == null || s == null)
			return false;
		
        return l.stream().anyMatch(x -> x.equalsIgnoreCase(s));
        
    }

}
