/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/


package at.gv.egiz.eaaf.core.impl.utils;

import java.util.List;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

/**
 * A <code>NodeList</code> implementation based on a <code>List</code>.
 * 
 * @see java.util.List
 * @see org.w3c.dom.NodeList
 */

public class NodeListAdapter implements NodeList {
  /** The <code>List</code> to wrap. */
  private List nodeList;
  
  /**
   * Create a new <code>NodeListAdapter</code>.
   * 
   * @param nodeList The <code>List</code> containing the nodes. 
   */
  public NodeListAdapter(List nodeList) {
    this.nodeList = nodeList;
  }

  /**
   * @see org.w3c.dom.NodeList#item(int)
   */
  public Node item(int index) {
    return (Node) nodeList.get(index);
  }

  /**
   * @see org.w3c.dom.NodeList#getLength()
   */
  public int getLength() {
    return nodeList.size();
  }

}
