package at.gv.egiz.eaaf.core.impl.utils;

import org.apache.commons.lang3.StringUtils;

import at.gv.egiz.eaaf.core.api.utils.IPendingRequestIdGenerationStrategy;
import at.gv.egiz.eaaf.core.exceptions.PendingReqIdValidationException;

/**
 * Simple pendingRequestId generation strategy that facilitates no extended validation
 * 
 * @author tlenz
 *
 */
public class SimplePendingRequestIdGenerationStrategy implements IPendingRequestIdGenerationStrategy {

	@Override
	public String generateExternalPendingRequestId() {
		return Random.nextLongRandom();
		
	}

	@Override
	public String validateAndGetPendingRequestId(String pendingReqId) throws PendingReqIdValidationException {
		return getPendingRequestIdWithOutChecks(pendingReqId);
				
	}

	@Override
	public String getPendingRequestIdWithOutChecks(String externalPendingReqId) throws PendingReqIdValidationException {
		if (StringUtils.isEmpty(externalPendingReqId))
			throw new PendingReqIdValidationException(externalPendingReqId, "PendingRequestId is empty or null");
		
		
		
		return externalPendingReqId;
	}

}
