package at.gv.egiz.eaaf.core.impl.idp.auth.attributes;

import java.text.DateFormat;
import java.text.SimpleDateFormat;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import at.gv.egiz.eaaf.core.api.data.PVPAttributeDefinitions;
import at.gv.egiz.eaaf.core.api.idp.IAttributeBuilder;
import at.gv.egiz.eaaf.core.api.idp.IAuthData;
import at.gv.egiz.eaaf.core.impl.idp.builder.attributes.BirthdateAttributeBuilder;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration("/SpringTest-context_eaaf_core.xml")
public class BirthdayAttrBuilderTest extends AbstractAttributeBuilderTest{
	
	private final IAttributeBuilder attrBuilde = new BirthdateAttributeBuilder();
	
	@Test
	public void performTest_ok() {
		try {
			final IAuthData authData = buildAuthData();
			final String value = attrBuilde.build(spConfig, authData, g);
			
			final DateFormat format = new SimpleDateFormat(PVPAttributeDefinitions.BIRTHDATE_FORMAT_PATTERN);			
			Assert.assertEquals("Birthday does NOT match", authData.getDateOfBirth(), format.parse(value));
			
		} catch (final Exception e) {
			Assert.assertTrue("Attr. builder has an exception", e == null);

		}
		
	}

}
