/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
package at.gv.egiz.eaaf.core.impl.idp.module.test;

import java.lang.reflect.InvocationTargetException;
import java.util.HashMap;
import java.util.Map;

import at.gv.egiz.eaaf.core.api.IRequest;
import at.gv.egiz.eaaf.core.api.idp.ISPConfiguration;
import at.gv.egiz.eaaf.core.exceptions.EAAFStorageException;
import at.gv.egiz.eaaf.core.impl.idp.auth.data.AuthProcessDataWrapper;

/**
 * @author tlenz
 *
 */
public class TestRequestImpl implements IRequest {

	private String processInstanceID = null; 
	private ISPConfiguration spConfig = null;
	private Map<String, Object> storage = new HashMap<String, Object>(); 
	
	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#requestedModule()
	 */
	@Override
	public String requestedModule() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#requestedAction()
	 */
	@Override
	public String requestedAction() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#isPassiv()
	 */
	@Override
	public boolean isPassiv() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#forceAuth()
	 */
	@Override
	public boolean forceAuth() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#getGenericData(java.lang.String)
	 */
	@Override
	public Object getRawData(String key) {
		return storage.get(key);
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#getGenericData(java.lang.String, java.lang.Class)
	 */
	@Override
	public <T> T getRawData(String key, Class<T> clazz) {
		return (T)storage.get(key);
	}


	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#getUniqueTransactionIdentifier()
	 */
	@Override
	public String getUniqueTransactionIdentifier() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#getUniqueSessionIdentifier()
	 */
	@Override
	public String getUniqueSessionIdentifier() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#getProcessInstanceId()
	 */
	@Override
	public String getProcessInstanceId() {
		return processInstanceID;
		
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#getAuthURL()
	 */
	@Override
	public String getAuthURL() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#getAuthURLWithOutSlash()
	 */
	@Override
	public String getAuthURLWithOutSlash() {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#isNeedAuthentication()
	 */
	@Override
	public boolean isNeedAuthentication() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#needSingleSignOnFunctionality()
	 */
	@Override
	public boolean needSingleSignOnFunctionality() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#setNeedSingleSignOnFunctionality(boolean)
	 */
	@Override
	public void setNeedSingleSignOnFunctionality(boolean needSSO) {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#isAuthenticated()
	 */
	@Override
	public boolean isAuthenticated() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#setAuthenticated(boolean)
	 */
	@Override
	public void setAuthenticated(boolean isAuthenticated) {
		// TODO Auto-generated method stub

	}

	/**
	 * @param processInstanceID the processInstanceID to set
	 */
	public void setProcessInstanceID(String processInstanceID) {
		this.processInstanceID = processInstanceID;
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#isAbortedByUser()
	 */
	@Override
	public boolean isAbortedByUser() {
		// TODO Auto-generated method stub
		return false;
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.moduls.IRequest#setAbortedByUser(boolean)
	 */
	@Override
	public void setAbortedByUser(boolean isAborted) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public String getSPEntityId() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setRawDataToTransaction(Map<String, Object> map) throws EAAFStorageException {
		storage.putAll(map);
		 
	}

	@Override
	public String getPendingRequestId() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getInternalSSOSessionIdentifier() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public void setInternalSSOSessionIdentifier(String internalSSOSessionId) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public boolean isNeedUserConsent() {
		// TODO Auto-generated method stub
		return false;
	}

	@Override
	public void setNeedUserConsent(boolean needConsent) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public ISPConfiguration getServiceProviderConfiguration() {
		return spConfig;
		
	}

	@Override
	public <T> T getServiceProviderConfiguration(Class<T> decorator) {
		return (T)spConfig;
	}

	@Override
	public void setRawDataToTransaction(String key, Object object) throws EAAFStorageException {
		storage.put(key, object);
		
	}

	public void setSpConfig(ISPConfiguration spConfig) {
		this.spConfig = spConfig;
	}

	@Override
	public <T> T getSessionData(Class<T> wrapper) {
		if (wrapper != null) {
			if (AuthProcessDataWrapper.class.isAssignableFrom(wrapper)) {
				try {					
					return wrapper.getConstructor(Map.class).newInstance(this.storage);
					
				} catch (NoSuchMethodException | SecurityException | InstantiationException | IllegalAccessException 
						| IllegalArgumentException | InvocationTargetException e) {
					throw new RuntimeException("Can NOT instance wrapper: " + wrapper.getName(), e);
					
				}
				
			}
			
			throw new RuntimeException("Can NOT wrap generic data into session data. "
					+ "Reason: Wrapper " + wrapper.getName() + " is NOT a valid wrapper");
			
		}
		
		return null;
	}
	
	
	

}
