/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/*
 * Licensed under the EUPL, Version 1.1 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * http://www.osor.eu/eupl/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 */
package at.gv.egiz.eaaf.core.api;


import at.gv.egiz.eaaf.core.exceptions.EAAFException;
import at.gv.egiz.eaaf.core.exceptions.PendingReqIdValidationException;

/**
 * @author tlenz
 *
 */
public interface IRequestStorage {

	/**
	 * Get a pending-request from storage
	 * 
	 * @param pendingReqID Id of the pending request
	 * @return
	 * @throws PendingReqIdValidationException if the pendingRequestId was invalid
	 */
	public IRequest getPendingRequest(String pendingReqID) throws PendingReqIdValidationException;
	
	/**
	 * Store a pending-request in storage
	 * 
	 * @param pendingRequest
	 * @throws EAAFException
	 */
	public void storePendingRequest(IRequest pendingRequest) throws EAAFException;
	
	/**
	 * Remove a pending-request from storage
	 * 
	 * @param pendingReqId Id of the pending request
	 */
	public void removePendingRequest(String pendingReqId);
	
	/**
	 * change the pendingRequestId of a pending-request
	 * 
	 * @param pendingRequest current pending-reqeust
	 * @return new pending-requestId
	 * @throws EAAFException
	 */
	public String changePendingRequestID(IRequest pendingRequest) throws EAAFException;
	
}
