/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
package at.gv.egiz.eaaf.core.api.data;


public class EAAFConstants {

	public static final String CONTENTTYPE_HTML_UTF8 = "text/html; charset=UTF-8";
	
	//http request parameters for process management
	public static final String PARAM_HTTP_TARGET_PENDINGREQUESTID = "pendingid";	
	public static final String PARAM_HTTP_ERROR_CODE = "errorid";
	 
	
	public static final String EIDAS_LOA_PREFIX = "http://eidas.europa.eu/LoA/";
	public static final String EIDAS_LOA_LOW = EIDAS_LOA_PREFIX + "low";
	public static final String EIDAS_LOA_SUBSTANTIAL = EIDAS_LOA_PREFIX + "substantial";
	public static final String EIDAS_LOA_HIGH = EIDAS_LOA_PREFIX + "high";
	
	public static final String EIDAS_LOA_MATCHING_MINIMUM = "minimum";
	public static final String EIDAS_LOA_MATCHING_EXACT = "exact";
	
	//Austrian specific prefixes for pseudonyms of users 
	public static final String URN_PART_WBPK = "wbpk+";
	public static final String URN_PART_EIDAS = "eidasid+";
	
	
	public static final String URN_PREFIX = "urn:publicid:gv.at";
	public static final String URN_PREFIX_BASEID = URN_PREFIX + ":baseid";
	public static final String URN_PREFIX_CDID = URN_PREFIX + ":cdid+";	  
	public static final String URN_PREFIX_BPK = URN_PREFIX_CDID + "bpk";		  
	public static final String URN_PREFIX_WBPK = URN_PREFIX + ":" + URN_PART_WBPK;
	public static final String URN_PREFIX_EIDAS = URN_PREFIX + ":" +  URN_PART_EIDAS;	
		
	//Authentication process data_constants
	public static final String UNIQUESESSIONIDENTIFIER  = "eaaf_uniqueSessionIdentifier";
	public static final String AUTH_DATA_CREATED 	    = "eaaf_authdata_created";
	
	
	public static final String PROCESS_ENGINE_PREFIX = "PARAMS_";
	public static final String PROCESS_ENGINE_PENDINGREQUESTID = PROCESS_ENGINE_PREFIX + PARAM_HTTP_TARGET_PENDINGREQUESTID;
	public static final String PROCESS_ENGINE_SERVICE_PROVIDER_ENTITYID = PROCESS_ENGINE_PREFIX + "uniqueSPId";
	public static final String PROCESS_ENGINE_SSL_CLIENT_CERTIFICATE = PROCESS_ENGINE_PREFIX + "holderofkey_cert";
	public static final String PROCESSCONTEXT_SP_CONFIG = PROCESS_ENGINE_PREFIX +  "spConfig";
	public static final String PROCESS_ENGINE_REQUIRES_NO_POSTAUTH_REDIRECT 
														= PROCESS_ENGINE_PREFIX + "requireNoPostAuthRedirect";
	
	public static final int ALLOWED_TIME_JITTER = 5; //minutes
	public static final String COUNTRYCODE_AUSTRIA = "AT";

	public static final String TESTCREDENTIALROOTOID = "1.2.40.0.10.2.4.1";
	
}
