/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
package at.gv.egiz.eaaf.core.api.data;

import java.io.Serializable;

import at.gv.egiz.eaaf.core.api.IRequest;

/**
 * @author tlenz
 *
 */
public class ExceptionContainer implements Serializable {

	private static final long serialVersionUID = 5355860753609684995L;
	private Throwable exceptionThrown = null;
	private IRequest pendingReq = null;
	
	
	/**
	 * 
	 */
	public ExceptionContainer(IRequest pendingReq, Throwable exception) {
		this.pendingReq = pendingReq;					
		this.exceptionThrown = exception;
		
	}
	
	/**
	 * @return the exceptionThrown
	 */
	public Throwable getExceptionThrown() {
		return this.exceptionThrown;
	}
	
	public IRequest getPendingRequest() {
		return this.pendingReq;
		
	}
	
	/**
	 * @return the uniqueSessionID
	 */
	public String getUniqueSessionID() {
		if (this.pendingReq != null)
			return this.pendingReq.getUniqueSessionIdentifier();
		else
			return null;
	}
	/**
	 * @return the uniqueTransactionID
	 */
	public String getUniqueTransactionID() {
		if (this.pendingReq != null)
			return this.pendingReq.getUniqueTransactionIdentifier();
		else
			return null;
	}

	/**
	 * @return the uniqueServiceProviderId
	 */
	public String getUniqueServiceProviderId() {
		if (this.pendingReq != null && 
				this.pendingReq.getServiceProviderConfiguration() != null)
			return this.pendingReq.getServiceProviderConfiguration().getUniqueIdentifier();
		else
			return null;
	}
	
	
	
	
}
