package at.gv.egiz.eaaf.core.api.gui;

import java.io.InputStream;

public interface IVelocityGUIBuilderConfiguration extends IGUIBuilderConfiguration {
	/**
	 * Get a specific classpath template-directory prefix, which is used 
	 *  to load a template from classpath by using <code>ClassLoader.getResourceAsStream(...)</code>  
	 * 
	 * @return Classpath directory, or null if the default directory should be used
	 */
	public String getClasspathTemplateDir();
		
	/** 
	 * Get the GUI template with a specific name
	 * 
	 * @param viewName Name of the template
	 * @return Tempate as <code>InputStream</code>, or null if default getTemplate method should be used  
	 */
	public InputStream getTemplate(String viewName);
	
}
