/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
package at.gv.egiz.eaaf.core.api.gui;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public interface ModifyableGuiBuilderConfiguration {

	/**
	 * Add a key/value pair into Velocity context.<br>
	 * <b>IMPORTANT:</b> external HTML escapetion is required, because it is NOT done internally
	 * 
	 * @param group Group element of the key parameter, or null if root element should be set
	 * @param key velocity context key
	 * @param value of this key
	 */
	void putCustomParameterWithOutEscaption(@Nullable String group, @Nonnull String key, @Nonnull Object value);

	/**
	 * Add a key/value pair into Velocity context.<br>
	 * All parameters get escaped internally
	 * 
	 * @param group Group element of the key parameter, or null if root element should be set
	 * @param key velocity context key
	 * @param value of this key
	 */
	void putCustomParameter(@Nullable String group, @Nonnull String key, @Nonnull String value);

}