/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/*******************************************************************************
 * Licensed under the EUPL, Version 1.1 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * http://www.osor.eu/eupl/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
package at.gv.egiz.eaaf.core.api.idp;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import at.gv.egiz.eaaf.core.api.IRequest;

/**
 * Basic interface of an authentication protocol implementation on IDP side
 * 
 * @author tlenz
 *
 */
public interface IModulInfo {
	
	/**
	 * Name of this IDP authentication module
	 * 
	 * @return
	 */
	public String getName();
	
	/**
	 * Authentication protocol identifier for this module
	 * 
	 * @return
	 */
	public String getAuthProtocolIdentifier();
	
	/**
	 * Generates a protocol specific error message
	 * 
	 * 
	 * @param e Exception that contains the error message
	 * @param request httpRequest object from servlet container
	 * @param response httpResponse object from servlet container
	 * @param protocolRequest incoming protocol request
	 * @return return <i>true</i> if a protocol specific error message was generated, otherwise <i>false</i>
	 * @throws Throwable
	 */
	public boolean generateErrorMessage(Throwable e,
			HttpServletRequest request, HttpServletResponse response,
			IRequest protocolRequest) throws Throwable;
	
	/**
	 * additional validation of a incoming authentication request 
	 * 
	 * @param request httpRequest object from servlet container
	 * @param response httpResponse object from servlet container
	 * @param pending incoming protocol request
	 * @return return <i>true</i> if the incoming request is valid, otherwise <i>false</i>
	 */
	public boolean validate(HttpServletRequest request, 
			HttpServletResponse response, IRequest pending);
}
