/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/**
 * Licensed under the EUPL, Version 1.1 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * http://www.osor.eu/eupl/
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 */
package at.gv.egiz.eaaf.core.api.idp.slo;

/**
 * @author tlenz
 *
 */
public interface SLOInformationInterface{
	

	/**
	 * get AssertionID which was used for Service Provider Single LogOut request 
	 * 
	 * @return
	 * SessionID (SessionIndex in case of SAML2)
	 */
	public String getSessionIndex();
	
	/**
	 * get user identifier which was used
	 * 
	 * @return
	 * bPK / wbPK (nameID in case of SAML2)
	 */
	public String getUserNameIdentifier();
	
	
	/**
	 * get protocol type which was used for authentication
	 * 
	 * @return
	 * return authentication protocol type
	 */
	public String getProtocolType();

	/**
	 * @return
	 */
	public String getUserNameIDFormat();
	
	/**
	 * Get the unique entityID of this Service-Provider
	 * 
	 * @return unique identifier, but never null
	 */
	public String getSpEntityID();
	
	public String getAuthURL();
	
	public String getServiceURL();
	
	public String getBinding();
	
	public void setUserNameIdentifier(String subjectNameId);
	
	public void setNameIDFormat(String format);
	
	public void setSessionIndex(String sessionIndex);
	
	
}
