package at.gv.egiz.eaaf.core.exceptions;


import javax.annotation.Nonnull;

import at.gv.egiz.eaaf.core.api.IRequest;

public class PendingReqIdValidationException extends EAAFException {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6886402432880791308L;

	private final String invalidInternalPendingReqId;
	private IRequest invalidPendingReq;
	
	/**
	 * 
	 * @param pendingReqId
	 * @param reason
	 */
	public PendingReqIdValidationException(String internalPendingReqId, @Nonnull String reason) {
		super("process.99", new Object[] {internalPendingReqId, reason});
		this.invalidInternalPendingReqId = internalPendingReqId;
		
	}

	public PendingReqIdValidationException(String internalPendingReqId, @Nonnull String reason, Throwable e) {
		super("process.99", new Object[] {internalPendingReqId, reason}, e );
		this.invalidInternalPendingReqId = internalPendingReqId;
	}

	/**
	 * Get the invalid pending-request
	 * 
	 * @return
	 */
	public IRequest getInvalidPendingReq() {
		return invalidPendingReq;
	}
	
	
	/**
	 * Get the internal invalid pending-request id
	 * 
	 * @return
	 */
	public String getInvalidInternalPendingReqId() {
		return invalidInternalPendingReqId;
	}

	public void setInvalidPendingReq(IRequest invalidPendingReq) {
		this.invalidPendingReq = invalidPendingReq;
		
	}
	
	

}
