package at.gv.egiz.eid.authhandler.modules.sigverify.moasig.impl.data;

import at.gv.egiz.eid.authhandler.modules.sigverify.moasig.api.data.IXMLSignatureVerificationResponse;

/**
 * 
 * 
 * @author tlenz
 *
 */

public class VerifyXMLSignatureResponse extends GenericSignatureVerificationResponse implements IXMLSignatureVerificationResponse {

  private static final long serialVersionUID = 8386070769565711601L;

/** The xmlDsigSubjectName to be stored */
  private String xmlDsigSubjectName;

  /** The xmlDSIGManifestCheckCode to be stored */
  private int xmlDSIGManifestCheckCode;
  /** The xmlDSIGManigest to be stored */
  private boolean xmlDSIGManigest;

  /**
   * The result of the signature manifest check. The default value <code>-1</code>
   * indicates that the signature manifest has not been checked.
   */
  private int signatureManifestCheckCode = -1;
  

  /* (non-Javadoc)
 * @see at.gv.egovernment.moa.id.auth.data.IVerifiyXMLSignatureResponse#getXmlDSIGManifestCheckCode()
 */
  @Override
public int getXmlDSIGManifestCheckCode() {
    return xmlDSIGManifestCheckCode;
  }

  /* (non-Javadoc)
 * @see at.gv.egovernment.moa.id.auth.data.IVerifiyXMLSignatureResponse#getXmlDsigSubjectName()
 */
  @Override
public String getXmlDsigSubjectName() {
    return xmlDsigSubjectName;
  }


  /* (non-Javadoc)
 * @see at.gv.egovernment.moa.id.auth.data.IVerifiyXMLSignatureResponse#setXmlDSIGManifestCheckCode(int)
 */
public void setXmlDSIGManifestCheckCode(int xmlDSIGManifestCheckCode) {
    this.xmlDSIGManifestCheckCode = xmlDSIGManifestCheckCode;
  }

  /* (non-Javadoc)
 * @see at.gv.egovernment.moa.id.auth.data.IVerifiyXMLSignatureResponse#setXmlDsigSubjectName(java.lang.String)
 */
public void setXmlDsigSubjectName(String xmlDsigSubjectName) {
    this.xmlDsigSubjectName = xmlDsigSubjectName;
  }


  /* (non-Javadoc)
 * @see at.gv.egovernment.moa.id.auth.data.IVerifiyXMLSignatureResponse#isXmlDSIGManigest()
 */
  @Override
public boolean isXmlDSIGManigest() {
    return xmlDSIGManigest;
  }

  /* (non-Javadoc)
 * @see at.gv.egovernment.moa.id.auth.data.IVerifiyXMLSignatureResponse#setXmlDSIGManigest(boolean)
 */
public void setXmlDSIGManigest(boolean xmlDSIGManigest) {
    this.xmlDSIGManigest = xmlDSIGManigest;
  }

  /* (non-Javadoc)
 * @see at.gv.egovernment.moa.id.auth.data.IVerifiyXMLSignatureResponse#getSignatureManifestCheckCode()
 */
  @Override
public int getSignatureManifestCheckCode() {
    return signatureManifestCheckCode;
  }

  /* (non-Javadoc)
 * @see at.gv.egovernment.moa.id.auth.data.IVerifiyXMLSignatureResponse#setSignatureManifestCheckCode(int)
 */           
public void setSignatureManifestCheckCode(int signatureManifestCheckCode) {
    this.signatureManifestCheckCode = signatureManifestCheckCode;
  }
  
}
