/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
package at.gv.egiz.eaaf.modules.pvp2.api.reqattr;

import java.util.List;

import javax.xml.namespace.QName;

import org.opensaml.common.SAMLObject;

import at.gv.egiz.eaaf.modules.pvp2.PVPConstants;

public interface EAAFRequestedAttributes extends SAMLObject {
    /** The Constant DEFAULT_ELEMENT_LOCAL_NAME. */
    String DEF_LOCAL_NAME = "RequestedAttributes";

    /** Default element name. */
    QName DEFAULT_ELEMENT_NAME = new QName(PVPConstants.EIDAT10_SAML_NS, DEF_LOCAL_NAME,
    		PVPConstants.EIDAT10_PREFIX);

    /** Local name of the XSI type. */
    String TYPE_LOCAL_NAME = "RequestedAttributesType";

    /** QName of the XSI type. */
    QName TYPE_NAME = new QName(PVPConstants.EIDAT10_SAML_NS, TYPE_LOCAL_NAME,
    		PVPConstants.EIDAT10_PREFIX);

    /**
     * Gets the attributes.
     *
     * @return the attributes
     */
    List<EAAFRequestedAttribute> getAttributes();
}
