/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
package at.gv.egiz.eaaf.modules.pvp2.impl.message;


import org.opensaml.Configuration;
import org.opensaml.xml.io.Unmarshaller;
import org.opensaml.xml.io.UnmarshallerFactory;
import org.opensaml.xml.io.UnmarshallingException;
import org.opensaml.xml.signature.SignableXMLObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class PVPSProfileRequest extends InboundMessage{
	private static final Logger log = LoggerFactory.getLogger(PVPSProfileRequest.class);
	
	private static final long serialVersionUID = 8613921176727607896L;

	private String binding = null;
	
	public PVPSProfileRequest(SignableXMLObject inboundMessage, String binding) {
		setSAMLMessage(inboundMessage.getDOM());
		this.binding = binding;
		
	}
	
	public String getRequestBinding() {
		return binding;
	}
	
	public SignableXMLObject getSamlRequest() {
		UnmarshallerFactory unmarshallerFactory = Configuration.getUnmarshallerFactory();
		Unmarshaller unmashaller = unmarshallerFactory.getUnmarshaller(getInboundMessage());
		
		try {
			return (SignableXMLObject) unmashaller.unmarshall(getInboundMessage());
			
		} catch (UnmarshallingException e) {
			log.warn("AuthnRequest Unmarshaller error", e);
			return null;
		}
		
	}

}
