/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
package at.gv.egiz.eaaf.modules.pvp2.impl.reqattr;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import org.opensaml.common.impl.AbstractSAMLObject;
import org.opensaml.xml.XMLObject;
import org.opensaml.xml.util.IndexedXMLObjectChildrenList;

import at.gv.egiz.eaaf.modules.pvp2.api.reqattr.EAAFRequestedAttribute;
import at.gv.egiz.eaaf.modules.pvp2.api.reqattr.EAAFRequestedAttributes;

public class EAAFRequestedAttributesImpl extends AbstractSAMLObject implements EAAFRequestedAttributes {

	 private final IndexedXMLObjectChildrenList<XMLObject> indexedChildren;
	
	public EAAFRequestedAttributesImpl(String namespaceURI, String elementLocalName, String namespacePrefix) {
		super(namespaceURI, elementLocalName, namespacePrefix);
		indexedChildren = new IndexedXMLObjectChildrenList<XMLObject>(this);
	}

	@Override
	public List<XMLObject> getOrderedChildren() {
		final List<XMLObject> children = new ArrayList<XMLObject>();
		children.addAll(indexedChildren);
		return Collections.unmodifiableList(children);
		
	}

	@Override
	public List<EAAFRequestedAttribute> getAttributes() {
		return (List<EAAFRequestedAttribute>) indexedChildren
				.subList(EAAFRequestedAttribute.DEFAULT_ELEMENT_NAME);
	}

}
