/*******************************************************************************
 * Copyright 2017 Graz University of Technology
 * EAAF-Core Components has been developed in a cooperation between EGIZ,  
 * A-SIT Plus, A-SIT, and Graz University of Technology.
 *
 * Licensed under the EUPL, Version 1.2 or - as soon they will be approved by
 * the European Commission - subsequent versions of the EUPL (the "Licence");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 * https://joinup.ec.europa.eu/news/understanding-eupl-v12
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 *  
 * This product combines work with different licenses. See the "NOTICE" text
 * file for details on the various modules and licenses.
 * The "NOTICE" text file is part of the distribution. Any derivative works
 * that you distribute must include a readable copy of the "NOTICE" text file.
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
/*******************************************************************************
 *******************************************************************************/
package at.gv.egiz.eaaf.modules.pvp2.impl.verification;

import javax.xml.namespace.QName;

import org.opensaml.common.SignableSAMLObject;
import org.opensaml.saml2.metadata.provider.MetadataProvider;
import org.opensaml.xml.XMLObject;
import org.opensaml.xml.signature.SignatureTrustEngine;

import at.gv.egiz.eaaf.modules.pvp2.api.metadata.IRefreshableMetadataProvider;

/**
 * @author tlenz
 *
 */
public class PVPSignedRequestPolicyRule extends
		AbstractRequestSignedSecurityPolicyRule {

	private IRefreshableMetadataProvider metadataProvider = null;
	
	/**
	 * @param metadataProvider 
	 * @param trustEngine
	 * @param peerEntityRole
	 */
	public PVPSignedRequestPolicyRule(MetadataProvider metadataProvider, SignatureTrustEngine trustEngine,
			QName peerEntityRole) {
		super(trustEngine, peerEntityRole);
		if (metadataProvider instanceof IRefreshableMetadataProvider)
			this.metadataProvider = (IRefreshableMetadataProvider) metadataProvider;
				
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.protocols.pvp2x.validation.AbstractRequestSignedSecurityPolicyRule#refreshMetadataProvider(java.lang.String)
	 */
	@Override
	protected boolean refreshMetadataProvider(String entityID) {
		if (metadataProvider != null)
			return metadataProvider.refreshMetadataProvider(entityID);
		
		return false;
		
	}

	/* (non-Javadoc)
	 * @see at.gv.egovernment.moa.id.protocols.pvp2x.validation.AbstractRequestSignedSecurityPolicyRule#getSignedSAMLObject(org.opensaml.xml.XMLObject)
	 */
	@Override
	protected SignableSAMLObject getSignedSAMLObject(XMLObject inboundData) {
		if (inboundData instanceof SignableSAMLObject)
			return (SignableSAMLObject) inboundData;
		
		else
			return null;
	}

}
